"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.adaptor = adaptor;
var adaptor_1 = require("../../adaptor");
var utils_1 = require("../../utils");
/**
 * @param chart
 * @param options
 */
function adaptor(params) {
    var dataTransform = function (params) {
        var options = params.options;
        var data = options.data;
        var defaultTransform = [
            {
                type: 'custom',
                callback: function (datum) { return ({ links: datum }); },
            },
        ];
        if ((0, utils_1.isArray)(data)) {
            if (data.length > 0) {
                (0, utils_1.set)(options, 'data', {
                    value: data,
                    transform: defaultTransform,
                });
            }
            else {
                delete options.children;
            }
        }
        else if ((0, utils_1.get)(data, 'type') === 'fetch' && (0, utils_1.get)(data, 'value')) {
            var transform = (0, utils_1.get)(data, 'transform');
            if ((0, utils_1.isArray)(transform)) {
                (0, utils_1.set)(data, 'transform', transform.concat(defaultTransform));
            }
            else {
                (0, utils_1.set)(data, 'transform', defaultTransform);
            }
        }
        return params;
    };
    return (0, utils_1.flow)(dataTransform, adaptor_1.mark, utils_1.transformOptions)(params);
}
